      SUBROUTINE gradiv_p(klevel, xcov, ycov, ld, gdx, gdy )
c
c    Auteur :   P. Le Van
c
c   ***************************************************************
c
c                                ld
c       calcul  de  (grad (div) )   du vect. v ....
c
c     xcov et ycov etant les composant.covariantes de v
c   ****************************************************************
c    xcov , ycov et ld  sont des arguments  d'entree pour le s-prog
c     gdx   et  gdy     sont des arguments de sortie pour le s-prog
c
c     
      USE parallel
      USE times
      IMPLICIT NONE
c
#include "dimensions.h"
#include "paramet.h"
#include "comdissipn.h"
#include "logic.h"

      INTEGER klevel
c
      REAL xcov( ip1jmp1,klevel ), ycov( ip1jm,klevel )
      REAL gdx( ip1jmp1,klevel ),   gdy( ip1jm,klevel )

      REAL div(ip1jmp1,llm)

      INTEGER l,ij,iter,ld
c
      EXTERNAL   SCOPY, diverg,  grad
      EXTERNAL   filtreg
      INTEGER ijb,ije,jjb,jje
c
c
c      CALL SCOPY( ip1jmp1*klevel,xcov,1,gdx,1 )
c      CALL SCOPY( ip1jm*klevel,  ycov,1,gdy,1 )
      
      ijb=ij_begin
      ije=ij_end
      gdx(ijb:ije,1:klevel)=xcov(ijb:ije,1:klevel)

      ijb=ij_begin
      ije=ij_end
      if(pole_sud) ije=ij_end-iip1
      gdy(ijb:ije,1:klevel)=ycov(ijb:ije,1:klevel)
      
c
      DO 10 iter = 1,ld
      
      call suspend_timer(timer_dissip)
      call exchange_Hallo(gdy,ip1jm,llm,1,0)
      call resume_timer(timer_dissip)
      
      CALL  diverg_p( klevel,  gdx , gdy, div          )
      
      jjb=jj_begin
      jje=jj_end
      CALL filtreg_p( div,jjb,jje, jjp1, klevel, 2,1, .true.,2 )
      
c      call exchange_Hallo(div,ip1jmp1,llm,0,1)
      
      call suspend_timer(timer_dissip)
      call exchange_Hallo(div,ip1jmp1,llm,1,1)
      call resume_timer(timer_dissip)
      
      CALL    grad_p( klevel,  div, gdx, gdy           )
c
      DO 5  l = 1, klevel
      
      if(pole_sud) ije=ij_end
      DO 3 ij = ijb, ije
        gdx( ij,l ) = - gdx( ij,l ) * cdivu
   3  CONTINUE
   
      if(pole_sud) ije=ij_end-iip1
      DO 4 ij = ijb, ije
        gdy( ij,l ) = - gdy( ij,l ) * cdivu
   4  CONTINUE

   5  CONTINUE
c
  10  CONTINUE
      RETURN
      END
